using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace kvalifikacije21
{
    class Program
    {
        static void Main(string[] args)
        {
            int N = int.Parse(Console.ReadLine().Split()[0]);

            int[,] mat = new int[N, N];
            List<int> sorte = new List<int>();
            List<int> neuspele = new List<int>();
            neuspele.Add(-1);

            for(int i = 0; i<N;i++)
            {
                string[] ucitaj = Console.ReadLine().Split();
                for (int j = 0; j < N; j++)
                    mat[i, j] = int.Parse(ucitaj[j]);
            }

            for(int i=0;i<N;i++)
            {
                for(int j=0; j<N; j++)
                {
                    if(mat[i,j]!=-1)
                    {
                        int p = mat[i, j], r = Pravougaonik(mat, i, j, N);
                        if (neuspele.Contains(p))
                        {
                            if (sorte.Contains(p))
                                sorte.Remove(p);
                        }
                        else
                        {
                            if (sorte.Contains(p))
                            {
                                sorte.Remove(p);
                                neuspele.Add(p);
                            }
                            else
                                if(r==p)
                                   sorte.Add(p);
                        }
                        }
                }
            }
            Console.WriteLine(sorte.Count);
        }
        static int Pravougaonik(int[,] mat, int i, int j, int n)
        {
            int a = mat[i,j];
            int l=0, k=i, c=j;
            while (k < n && mat[k,c]==a)
            {
                mat[k, c] = -1;
                k++;
                l++;
            }
            c++;
            while (c < n && mat[i,c]==a)
            {
                k = i;
                while (k < i+l && mat[k,c]==a)
                {
                    mat[k, c] = -1;
                    k++;
                }
                if (k<i+l)
                {
                    a = -1;
                    break;
                }
                c++;
            }
            return a;
        }
    }
}